<script setup lang="ts">
import type { Promo, Student } from '@/entities';
import { usePromoStore } from '@/stores/promo';
import { useStudentStore } from '@/stores/student';
import { storeToRefs } from 'pinia';
import { onMounted, ref, watch } from 'vue';

const props = defineProps<{
    promo: Promo
}>();

const studentCount = ref(props.promo.studentNumber);
const studentToRemove = ref<Student[]>([]);

const promoStore = usePromoStore();
const studentStore = useStudentStore();
const { students } = storeToRefs(studentStore);
const studentInput = ref<Student[]>([])

watch([students, studentCount], () => {
    let list: Student[] = [];
    studentToRemove.value = [...students.value].splice(studentCount.value);
    for (let i = 0; i < studentCount.value; i++) {
        if (students.value[i]) {
            list.push(studentInput.value[i] ? studentInput.value[i]:{...students.value[i]});
        } else {
            list.push(studentInput.value[i] ? studentInput.value[i]:{ name: '', promo: props.promo });
        }
    }
    studentInput.value = list;
})


onMounted(() => {
    if (props.promo.id) {
        studentStore.fetchStudents(props.promo.id);
    }
});


function handleForm() {
    let toSave = studentInput.value.filter(item => !item.id && item.name);
    let toEdit = studentInput.value.filter((item,index) => item.id && item.name && item.name != students.value[index].name)

    if(props.promo.studentNumber != studentCount.value) {
        promoStore.updatePromo({...props.promo, studentNumber: studentCount.value});
    }
    if(toSave.length > 0) {
        studentStore.persistStudent(toSave);
    }
    if(toEdit.length > 0) {
        for(const item of toEdit) {
            studentStore.updateStudent(item);
        }
    }
    if(studentToRemove.value.length > 0) {
        for (const item of studentToRemove.value) {
            studentStore.removeStudent(item);
        }
    }
}
</script>


<template>
    <el-form>
        <h2>Liste des apprenant·es</h2>

        <el-form-item label="Nombre d'apprenant·es">
            <el-input-number v-model="studentCount"></el-input-number>
        </el-form-item>
        <el-form-item v-for="(student, index) of studentInput" :key="index" :label="String(index + 1)">
            <el-input v-model="student.name" placeholder="Nom de l'apprenant·es"></el-input>
        </el-form-item>

        <el-form-item>
            <el-button type="primary" @click="handleForm()">
                Valider
            </el-button>

        </el-form-item>
    </el-form>
</template>